#include"MeshLoader.h"
#include"AneuMeshLoader.h"
#include <iostream>
#include <algorithm>

int main(int argc, char* argv[])
{
        MeshLoader* Mesh = new AneuMeshLoader;
        std::string file_P = "Mesh.aneu";
	try
	{
                Mesh->LoadMesh(file_P);
                Mesh->print();



                std::cout << "Finite Elements by 3 nodes:" << std::endl;
                std::vector<FiniteElement> finelems = Mesh->getFiniteElementByIdNodes(13, 14, 10);
                std::for_each(finelems.begin(), finelems.end(), [](const FiniteElement& elem)
		{
                        std::cout << elem;
		});
		finelems.clear();


                std::cout << "Finite Elements by egde:" << std::endl;
                finelems = Mesh->getFiniteElementByEdge(9, 37);
                std::for_each(finelems.begin(), finelems.end(), [](const FiniteElement& elem)
		{
                        std::cout << elem;
		});
		finelems.clear();

		std::cout << "Finite Elements by id material (1):" << std::endl;
                finelems = Mesh->getFiniteElementById(1);
                std::for_each(finelems.begin(), finelems.end(), [](const FiniteElement& elem)
		{
                        std::cout << elem;
		});
		finelems.clear();

		std::cout << "Nodes by id Surface (21):" << std::endl;
                std::vector<Node> nodes = Mesh->getNodeByIdSurface(21);
                std::for_each(nodes.begin(), nodes.end(), [](const Node& elem)
		{
                        std::cout << elem;
		});
		nodes.clear();


		std::cout << "Boundary finite elements by id Surface (21):" << std::endl;
                std::vector<BoundaryFiniteElement> boundelems = Mesh->getBoundaryFiniteElementByIdSuface(21);
                std::for_each(boundelems.begin(), boundelems.end(), [](const BoundaryFiniteElement& elem)
		{
                        std::cout << elem;
		});

		std::cout << std::setw(8)<<"id:" << std::setw(12) << "Neighbours:" << std::endl;
                std::vector<std::set<sizeT>> neighbour_nodes = Mesh->getNeighboursNodes();

                for (std::vector<std::set<sizeT>>::iterator neighbours = neighbour_nodes.begin(); neighbours != neighbour_nodes.end(); neighbours++)
		{
                        std::cout << std::setw(8) << neighbours - neighbour_nodes.begin() + 1<< ":";
                        std::for_each(neighbours->begin(), neighbours->end() ,[](sizeT Id)
			{
                                std::cout << std::setw(8) << Id;
			});

			std::cout << std::endl;
		}
	
	
                Mesh->InsertMidNodes();
		std::cout << "Insert middle nodes:" << std::endl;

                std::cout << "Changed mesh: " << std::endl;
                Mesh->print();
		
	}
	catch(std::exception & ex)
	{
		std::cout << ex.what();
	}

        delete Mesh;

	return 0;

}
